import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import java.lang.*;

public class colors extends JFrame implements ActionListener
{

  public static void main(String[] args)
  {
    colors myColors = new colors();
    myColors.setVisible(true);
  }

  // Universal Variables
  Vector colors = new Vector(1);
  Vector children = new Vector(0);
  String g1="";
  String g2="";
  ErrorWindow myAlert = new ErrorWindow();


  /********* GUI VARIABLES *********/
  /**/
  /**/ JComboBox parentColor1 = new JComboBox(colors);
  /**/ JComboBox parentColor2 = new JComboBox(colors);
  /**/
  /**/ JCheckBox noBase1 = new JCheckBox("No Shell Base Color", true);
  /**/ JCheckBox noBase2 = new JCheckBox("No Shell Base Color", true);
  /**/
  /**/ JCheckBox noStripes1 = new JCheckBox("No Stripes", true);
  /**/ JCheckBox noStripes2 = new JCheckBox("No Stripes", true);
  /**/
  /**/ JCheckBox lightBody1 = new JCheckBox("Light Body", true);
  /**/ JCheckBox lightBody2 = new JCheckBox("Light Body", true);
  /**/
  /**/ JTextArea output = new JTextArea("Output Field", 9, 33);
  /**/
  /**/ JLabel statusBar = new JLabel("Ready");
  /**/
  /**/ JButton go = new JButton("Find Possible Offspring Colors");
  /**/
  /**/ JScrollPane scrollPane = new JScrollPane(output);
  /**/
  /********** END GUI VARIABLES **********/





  public colors()
  {
    // Main Window Initizlization
    super("Color Inheritance - v 1.2");
    setSize(/*w*/400, /*h*/ 400);
    System.out.println("Window Built");


    // Basic Startup Sequences
    setColors();


    // Panels
    System.out.println("Buildling Panels...");

    JPanel top = new JPanel();
    JPanel midRight = new JPanel();
    JPanel midLeft = new JPanel();
    JPanel midBottom = new JPanel();
    JPanel midCenter = new JPanel();
    JPanel low = new JPanel();

    JPanel mid = new JPanel();
    JPanel all = new JPanel();

    mid.setLayout(new BorderLayout());
    mid.add(midCenter, BorderLayout.CENTER);
    mid.add(midBottom, BorderLayout.SOUTH);

    midCenter.setLayout(new GridLayout(1,2,/*hg*/5,/*vg*/1));
    midCenter.add(midLeft);
    midCenter.add(midRight);

    all.setLayout(new BorderLayout());
    all.add(top, BorderLayout.NORTH);
    all.add(mid, BorderLayout.CENTER);
    all.add(low, BorderLayout.SOUTH);
    all.setBackground(Color.gray);

    // SubPanels
    JPanel colorPanel1 = new JPanel();
    JPanel colorPanel2 = new JPanel();
    JPanel genePanel1 = new JPanel();
    JPanel genePanel2 = new JPanel();

    midRight.setLayout(new BorderLayout());
    midRight.add(colorPanel2, BorderLayout.NORTH);
    midRight.add(genePanel2, BorderLayout.CENTER);

    midLeft.setLayout(new BorderLayout());
    midLeft.add(colorPanel1, BorderLayout.NORTH);
    midLeft.add(genePanel1, BorderLayout.CENTER);

    // SubPanel Components
    colorPanel1.setLayout(new GridLayout(2,1));
    colorPanel2.setLayout(new GridLayout(2,1));
    JLabel p1 = new JLabel(" Parent 1's Color:");
    JLabel p2 = new JLabel(" Parent 2's Color:");
    colorPanel1.add(p1);
    colorPanel2.add(p2);
    colorPanel1.add(parentColor1);
    colorPanel2.add(parentColor2);

    genePanel1.setLayout(new GridLayout(4, 1));
    JLabel known1 = new JLabel(" Recessives Carried (P1):");
    genePanel1.add(known1);
    genePanel1.add(noBase1);
    genePanel1.add(noStripes1);
    genePanel1.add(lightBody1);

    genePanel2.setLayout(new GridLayout(4, 1));
    JLabel known2 = new JLabel(" Recessives Carried (P2):");
    genePanel2.add(known2);
    genePanel2.add(noBase2);
    genePanel2.add(noStripes2);
    genePanel2.add(lightBody2);

    scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

    low.setLayout(new GridLayout(2,1));
    low.add(go);
    low.add(statusBar);
    midBottom.add(scrollPane);

    // Component Modification and Addition
    System.out.println("Modifying Componants...");

    output.setLineWrap(true);
    output.setWrapStyleWord(true);

    parentColor1.setSelectedIndex(0);
    parentColor2.setSelectedIndex(0);

    midRight.setBackground(Color.LIGHT_GRAY);
    midLeft.setBackground(Color.LIGHT_GRAY);
    midCenter.setBackground(Color.LIGHT_GRAY);



    //MENU BAR
    JMenuBar topMenuBar = new JMenuBar();
    JMenu options = new JMenu("Options");
    JMenuItem exit = new JMenuItem("Exit");
    JMenuItem help = new JMenuItem("Help");

    all.add(topMenuBar, BorderLayout.NORTH);
    topMenuBar.add(options);
    //options.add(help);
    options.add(exit);

    help.addActionListener(this);
    exit.addActionListener(this);


    // Add Action Listeners
    System.out.println("Adding Action Listeners...");
    go.addActionListener(this);



    // ADD ALL TO CONTENT PANE
    Container pane = getContentPane();
    pane.add(all);

    System.out.println("CONTENT PANE SET");
    System.out.println("Building Window Destroyer...");

    //SET ICON
    setIconImage(new ImageIcon("icon.gif").getImage());

    WindowDestroyer myListener = new WindowDestroyer();
    addWindowListener(myListener);

    System.out.println("READY");
    myAlert.setVisible(false);

    this.setLocation(/*x*/300, /*y*/200);
  }










  /***********************************************/
  /*           ACTION PERFORMED METHOD           */
  /***********************************************/


  public void actionPerformed(ActionEvent event)
  {
    String command=event.getActionCommand();
    System.out.println(" ");
    System.out.println(" ");
    System.out.println(command);

    if (command.equals("Exit"))
    {
        System.exit(0);
    }else

    if (command.equals("Find Possible Offspring Colors"))
    {
      boolean check=checkColorCombo();

      if (check==true)
      {
        int a=0;
        //find potential offspring colors
        System.out.println("Finding Potential Offpring Colors...");
        children.clear();
        checkColorCombo();

        String temp="";
        String junk="";

        for (int i=0; i<children.size(); i++)
        {
          junk=children.elementAt(i).toString();
          a=Integer.parseInt(junk);
          temp=temp+colors.elementAt(a)+'\n';
        }

        temp="Potential Offspring Colors are: \n"+temp;
        temp=temp+"\n"+"Note: Light Striped Purple pink vs. ivory inheritance is "+
            "not 100% clear so far, so either could possibly result unless the only "+
            "parent colors in question are Light Striped Purple (ivory) and either "+
            "ivory or blue. Also note that results to cross-color category crosses "+
            "(Purple to Olive, Olive to Burgundy, etc.) are not certain! In those "+
            "cases, only a few of the colors listed will most likely appear.";
        output.setText(temp);
        statusBar.setText("colors found: "+children.size());
      }else
      {
        //cannot find potential offspring colors
        System.out.println("Unable to find Potential Offspring Colors.");
        output.setText("Unable to find Potential Offspring Colors. "+
                       "the inheritance pattern for the traits expressed in the "+
                       "selected colors is unknown between the selected colors. "+
                       "Inheritance is only known for purple/purple, yellow-brown/yellow-brown "+
                       "and olive/olive crosses. Cross category crosses and burgundy crosses have "+
                       "not yielded enough information to predict offspring colors.");
      }


    }else
    {
      System.out.println("WARNING: UNCAUGHT COMMAND!");
      System.out.println("Please report this error and the series of events "+
                         "that lead to it to the programmer, Donya Quick, via "+
                         "e-mail: DonyaVQ@netscape.net");
    }
  }







  /***********************************************/
  /*           EXTRA METHODS & CLASSES           */
  /***********************************************/


  public void setColors()
  {
    // Variables
    String input="";
    String color="";
    IO myIO = new IO();
    int i=0;

    input = myIO.fromFile("colors.txt");
    myIO.close();
    colors.clear();

    StringTokenizer myTok = new StringTokenizer(input, ";");

    System.out.println(myTok.hasMoreTokens());


    System.out.println("Beginning Color Build...");
    System.out.println();

    while (myTok.hasMoreTokens() && i<21)
    {
      color="";
      color=myTok.nextToken();
      colors.add(i, color);

      System.out.println(i+" "+colors.elementAt(i));

      i++;
    }

    System.out.println();
    System.out.println("Colors Loaded.");
  }






  public boolean checkColorCombo()
  {
    int item1=parentColor1.getSelectedIndex();
    int item2=parentColor2.getSelectedIndex();

    validateRecessives(parentColor1, noBase1, noStripes1, lightBody1);
    validateRecessives(parentColor2, noBase2, noStripes2, lightBody2);

    //Check Burgundies
    //if (item1==19 || item2==19 || item1==20 || item2==20)
    //{
    //  myAlert.setVisible(true);
    //  return false;
    //}else
    //Check Yellow-Browns
    if (-1<item1 && item1<8 && -1<item2&& item2<8)
    {
      System.out.println("Both Yellow-Brown");
      FindYellowBrownOffspring();
      return true; //both are yellow-brown colors
    }else
    if (7<item1 && item1<15 && 7<item2 &&item2<15)
    {
      System.out.println("Both Purple");
      FindPurpleOffspring();
      return true; // both are purple colors
    }else

    //Check Olives
    if (14<item1 && item1<19 && 14<item2 && item2<19)
    {
      System.out.println("Both Olive");
      FindOliveOffspring();
      return true; // both are olive colors
    }else
    if (14<item1 && item1<19 && (item2==0 || item2==3))
    {
      System.out.println("Olive and Null");
      FindOliveOffspring();
      return true; // olive colors with ivory/blue
    }else
    if ((item1==0 || item1==3) && 14<item2 && item2<19)
    {
      System.out.println("Olive and Null (2)");
      FindOliveOffspring();
      return true; // olive colors with ivory/blue
    }else

    //Check Purples
    if ((7<item1 && item1<15) && (item2==0 || item2==3))
    {
      System.out.println("Purple and Null");
      FindPurpleOffspring();
      return true; // purple colors with ivory/blue
    }else
    if ((item1==0 || item1==3) && (7<item2 && item2<15))
    {
      System.out.println("Purple and Null (2)");
      FindPurpleOffspring();
      return true; // purple colors with ivory/blue
    }else

    if ((item1==0 || item1==3) && (item2!=19 && item2 !=20))
    {
      FindYellowBrownOffspring();
      return true; //ivory and blue can go accross color categories
    }else


    /********* BURGUNDY CROSSES **********/

    if (((item1==19 || item1==20) && (item2==19 || item2==20))|| // BOTH BURGUNDY
        ((item1==0 || item1==3) && (item2==19 || item2==20)) || //IVORY/BLUE BURGUNDY
        ((item2==0 || item2==3) && (item1==19 || item1==20))) //IVORY/BLUE BURGUNDY
    {
      int i=0;
      System.out.println("Burgundy cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindBurgundyOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else



    if (((18<item1 && 21>item1) && (-1<item2 && 8>item2)) ||// BURGUNDY/YELLOW-BRWN
        ((18<item2 && 21>item2) && (7<item1 && 15>item1)) || //BURGUNDY/PURPLE
        ((18<item1 && 21>item1) && (7<item2 && 15>item2)) || //BURGUNDY/PURPLE
        ((18<item2 && 21>item2) && (-1<item1 && 8>item1)))// BURGUNDY/YELLOW-BRWN
    {
      int i=0;
      System.out.println("Burgundy cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindBurgundyOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else


    if (((18<item1 && 21>item1) && (14<item2 && 19>item2)) ||
        ((18<item2 && 21>item2) && (14<item1 && 19>item1)))// BURGUNDY/OLIVE
    {
      int i=0;
      System.out.println("Burgundy cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindOliveOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }

      FindBurgundyOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else



    /********* OLIVE/Yellow-Brown CROSS **************/
    if (((-1<item1 && 8>item1) && (14<item2 && 19>item2)) ||
        ((-1<item2 && 8>item2) && (14<item1 && 19>item1)))
    {
      int i=0;
      System.out.println("Olive cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindOliveOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else



    /********* OLIVE/PURPLE CROSS **************/
    if (((7<item1 && 15>item1) && (14<item2 && 19>item2)) ||
        ((7<item2 && 15>item2) && (14<item1 && 19>item1)))
    {
      int i=0;
      System.out.println("Olive/Purple cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindOliveOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      FindPurpleOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();


      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else


    /********* PURPLE/Yellow-Brown CROSS **************/
    if (((7<item1 && 15>item1) && (-1<item2 && 8>item2)) ||
        ((7<item2 && 15>item2) && (-1<item1 && 8>item1)))
    {
      int i=0;
      System.out.println("Purple cross");
      System.out.println("Finding Purple Offspring...");
      Vector add = new Vector();
      add.clear();
      FindPurpleOffspring();
      for (i=0; i<children.size(); i++)
      {
        add.add(i, children.elementAt(i));
        System.out.println(add.elementAt(i));
      }
      System.out.println("Finding Yellow-Brown Offspring...");

      FindYellowBrownOffspring();
      for (int a=0; a<children.size(); a++)
      {
        add.add(i, children.elementAt(a));
        System.out.println(add.elementAt(i));
        i++;
      }
      System.out.println();

      children.clear();
      for (i=0; i<add.size(); i++)
      {
        children.add(i, add.elementAt(i));
      }

      //ClearRepeats(); <---this function is faulty

      System.out.println();

      return true; //burgundy cross results in purple and normal offspring
    }else




    {
      myAlert.setVisible(true);
      return false; // neither parent is in the same color category
      // or both are burgundy
    }
  }




  public void ClearRepeats()
  {
    Vector temp = new Vector(0);
    String junk1 = "";
    String junk2 = "";
    boolean duplicated=false;
    int i=0;

    for (i=0; i<children.size(); i++)
    {
      temp.add(i, children.elementAt(i));
    }

    children.clear();

    for (i=0; i<temp.size(); i++)
    {
      junk1=(String)temp.elementAt(i);

      for (int a=i; a<temp.size(); a++)
      {
        junk2 = (String) temp.elementAt(a);

        if (junk1.equals(junk2))
        {
          duplicated=true;
        }

        if (duplicated==true)
        {
          temp.removeElementAt(a);
        }
      }

      duplicated=false;
    }

    children.clear();
    for (i=0; i<temp.size(); i++)
    {
      children.add(i, temp.elementAt(i));
    }

  }





  public void validateRecessives(JComboBox combo, JCheckBox base,
                                 JCheckBox stripes, JCheckBox body)
  {
    int i = combo.getSelectedIndex();

    System.out.println("Validating Recessives for "+combo.getSelectedItem()+"...");

    //Check for Shell Base Pigment
    if (i==0 || i==3 || i==6 || i==7 || i==8 || i==9 || i==13)
    {
      base.setSelected(true);
    }

    //Check for Stripes
    if (i==0 || i==1 || i==3 || i==4 || i==11 || i==14 || i==16 || i==18)
    {
      stripes.setSelected(true);
    }

    //Check for Body Color
    if (i==0 || i==1 || i==2 || i==6 || i==8 || i==9 || i==10 || i==11 || i==15 || i==16 || i==19)
    {
      body.setSelected(true);
    }

    System.out.println("Recessives Validated.");
    System.out.println();

    g1="";
    g2="";
    g1=BuildGenotype(parentColor1, noBase1, noStripes1, lightBody1);
    g2=BuildGenotype(parentColor2, noBase2, noStripes2, lightBody2);
  }



  public void FindYellowBrownOffspring()
  {
    children.clear();
    int p1 = parentColor1.getSelectedIndex();
    int p2 = parentColor2.getSelectedIndex();

    String x="";

    //0 ivory
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="0";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- ivory");
    }

    //1 golden
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="1";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- golden");
    }

    //2 striped yellow
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="2";

      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- striped yellow");
    }

    //3 blue
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="3";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- blue");
    }


    //4 jade
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="4";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- jave");
    }

    //5 wild
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="5";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- wild");
    }

    //6 red-white
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="6";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- red-white");
    }


    //7 red-brown
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="7";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- red-brown");
    }


    int i=2;
  }




  public void FindBurgundyOffspring()
  {
    String x = "0";
    children.clear();
    int p1 = parentColor1.getSelectedIndex();
    int p2 = parentColor2.getSelectedIndex();

    //20 dark burgundy
    // abc
    if ( (g1.charAt(1) == 'A' && g2.charAt(1) == 'A') &&
        (g1.charAt(3) == 'B' && g2.charAt(3) == 'B') &&
        (g1.charAt(5) == 'C' && g2.charAt(5) == 'C'))
    {
      x = "20";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- dark burgundy");
    }

    //19 burgundy
    x = "19";
    if(!children.contains(x))
      {
        children.add(x);
      }

    System.out.println("- burgundy");
  }









  public void FindPurpleOffspring()
  {
    String x="0";
    children.clear();
    int p1 = parentColor1.getSelectedIndex();
    int p2 = parentColor2.getSelectedIndex();

    System.out.println("Adding Purple Offspring...");

    //0 ivory
    // abc
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      System.out.println("- ivory");
      x="0";
      if(!children.contains(x))
      {
        children.add(x);
      }

    }

    //11 plain purple
    // aBc
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      System.out.println("- plain purple");
      x="11";
      if(!children.contains(x))
       {
         children.add(x);
       }

    }

    //10 striped purple
    // ABc
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="10";
      System.out.println("- striped purple");
      if(!children.contains(x))
      {
        children.add(x);
      }

    }

    //3 blue
    //abC
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="3";
      System.out.println("- blue");
      if(!children.contains(x))
      {
        children.add(x);
      }

    }


    //14 dark plain purple
    // aBC
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="14";
      System.out.println("- plain purple");
      if(!children.contains(x))
      {
        children.add(x);
      }

    }

    //12 dark striped purple
    // ABC
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="12";
      System.out.println("- dark striped purple");
      if(!children.contains(x))
      {
        children.add(x);
      }

    }

    //8-9 light striped purple ivory/pink
    // Abc
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="8";
      if(!children.contains(x))
      {
        children.add(x);
      }

      x="9";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- light striped purple");
    }


    //13 dark striped purple CSB
    // AbC
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="13";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- dark striped purple CSB");
    }


    int i=2;
  }




  public void FindOliveOffspring()
  {
    String x="0";
    children.clear();
    int p1 = parentColor1.getSelectedIndex();
    int p2 = parentColor2.getSelectedIndex();

    //0 ivory
    // abc
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="0";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- ivory");
    }

    //16 plain olive
    // aBc
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="16";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- plain olive");
    }

    //15 striped olive
    // ABc
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(5)=='c' && g2.charAt(5)=='c'))
    {
      x="15";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- striped olive");
    }

    //3 blue
    //abC
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(3)=='b' && g2.charAt(3)=='b') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="3";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- blue");
    }


    //18 dark plain olive
    // aBC
    if ((g1.charAt(1)=='a' && g2.charAt(1)=='a') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="18";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- dark plain olive");
    }

    //17 dark striped olive
    // ABC
    if ((g1.charAt(0)=='A' || g2.charAt(0)=='A') &&
        (g1.charAt(2)=='B' || g2.charAt(2)=='B') &&
        (g1.charAt(4)=='C' || g2.charAt(4)=='C'))
    {
      x="17";
      if(!children.contains(x))
      {
        children.add(x);
      }

      System.out.println("- dark striped olive");
    }

    int i=2;
  }





  public String BuildGenotype(JComboBox combo, JCheckBox base,
                              JCheckBox stripes, JCheckBox body)
  {
    int i=combo.getSelectedIndex();
    String genotype="";

    // Yellow-Brown Color Category
    if (i==0)
    {
      genotype="aabbcc";
    }else
    if (i==1)
    {
      genotype="aaB?cc";
    }else
    if (i==2)
    {
      genotype="A?B?cc";
    }else
    if (i==3)
    {
      genotype="aabbC?";
    }else
    if (i==4)
    {
      genotype="aaB?C?";
    }else
    if (i==5)
    {
      genotype="A?B?C?";
    }else
    if (i==6)
    {
      genotype="A?bbcc";
    }else
    if (i==7)
    {
      genotype="A?bbC?";
    }else

    //Purple Colors
    if (i==8)
    {
      genotype="A?bbcc";
    }else
    if (i==9)
    {
      genotype="A?bbcc";
    }else
    if (i==10)
    {
      genotype="A?B?cc";
    }else
    if (i==11)
    {
      genotype="aaB?cc";
    }else
    if (i==12)
    {
      genotype="A?B?C?";
    }else
    if (i==13)
    {
      genotype="A?bbC?";
    }else
    if (i==14)
    {
      genotype="aaB?C?";
    }else

    // Olive Colors
    if (i==15)
    {
      genotype="A?B?cc";
    }else
    if (i==16)
    {
      genotype="aaB?cc";
    }else
    if (i==17)
    {
      genotype="A?B?C?";
    }else
    if (i==18)
    {
      genotype="aaB?C?";
    }

    if (i==19)
    {
      genotype="A?B?cc";
    }
    if (i==20)
    {
      genotype="A?B?C?";
    }

    //Eliminate ?s where possible
    String temp=""+genotype.charAt(0);

    if (stripes.isSelected() && genotype.charAt(1)=='?')
    {
      temp = temp + "a";
    }else
    {
      temp=temp+genotype.charAt(1);
    }

    temp=temp+genotype.charAt(2);
    if (base.isSelected() && genotype.charAt(3)=='?')
    {
      temp = temp + "b";
    }else
    {
      temp=temp+genotype.charAt(3);
    }


    temp=temp+genotype.charAt(4);
    if (body.isSelected() && genotype.charAt(5)=='?')
    {
      temp = temp + "c";
    }else
    {
      temp=temp+genotype.charAt(5);
    }


    genotype=temp;

    System.out.println("Genotype: "+genotype);

    return genotype;
  }



















  //////// WINDOW DESTROYER CLASS
  public class WindowDestroyer extends WindowAdapter
  {
    public void windowClosing(WindowEvent event)
    {
      System.exit(0);
    }
  }





  ///////// CLASS IO //////////////
  public class IO
  {
  //INPUT DATA

    BufferedReader inputStream = null;

    public String fromFile(String name)
    {
      if (name==null)
      {
        return null;
      }
      if(inputStream==null)
      {
        try{
          inputStream=new BufferedReader(new FileReader(name));
        }
        catch (FileNotFoundException e1)
        {
          System.out.println("Unable to locate file named " + name);
          //decoder2.decoder.field2.setText("Unable to locate file named " + name);
          return null;
        }
      }
      String retVal = null;
      try{
      retVal = inputStream.readLine();
      }
      catch (IOException ioe)
      {
        System.out.println("Fatal Error, program ended. 1");
        System.exit(0);
      }
      try
      {
        if (retVal==null)
        {
          inputStream.close();
          inputStream=null;
        }
      }
      catch (IOException ioe2)
      {
        System.out.println("Fatal Error, Program ended. 2");
      }
      return retVal;
    }

    //Output

    PrintWriter outputStream=null;

    public void toFile(String name, String data)
    {
      if (name==null)
      {
        return;
      }

      if (outputStream==null)
      {
        try{
          outputStream = new PrintWriter (new FileOutputStream (name));
        }
        catch (FileNotFoundException fnfe2)
        {
          System.out.println("Unable to locate file named " +name+". (2)");
          //decoder2.decoder.field2.setText("Unable to locate file named " +name+". (2)");
        }
      }
      outputStream.println(data);
    }

    public void close()
    {
      if (inputStream!=null)
      {
        try{
          inputStream.close();
        }
        catch (IOException ioe3)
        {
          System.out.println("Fatal Error, program ended.");
        }
        inputStream=null;
      }
      if (outputStream!=null)
      {
        outputStream.close();
        outputStream=null;
      }
    }
  }




  // Error Window
  public class ErrorWindow extends JFrame implements ActionListener
  {
    public ErrorWindow()
    {
      super("Error");
      setSize(/*w*/280, /*h*/150);

      JLabel message1 = new JLabel("  Error: you must select two colors of the same");
      JLabel message2 = new JLabel("  color categegory, such as purple and purple,");
      JLabel message3 = new JLabel("  yellow-brown and yellow-brown, or olive and");
      JLabel message4 = new JLabel("  olive. Burgundy crosses are not possible to");
      JLabel message5 = new JLabel("  find. For more information see the help file.");

      JPanel message = new JPanel(new GridLayout(/*row*/5, /*col*/1));
      message.add(message1);
      message.add(message2);
      message.add(message3);
      message.add(message4);
      message.add(message5);

      JPanel all = new JPanel();
      all.setLayout(new BorderLayout());
      all.add(message, BorderLayout.CENTER);

      JButton ok = new JButton("OK");
      ok.addActionListener(this);

      all.add(ok, BorderLayout.SOUTH);

      // ADD ALL TO CONTENT PANE
      Container pane = getContentPane();
      pane.add(all);

      //SET ICON
      setIconImage(new ImageIcon("alert.gif").getImage());

      //WindowDestroyer myListener = new WindowDestroyer();
      //addWindowListener(myListener);

      System.out.println("COLOR ALERT");

      this.setLocation(/*x*/400, /*y*/300);
    }

    public void actionPerformed(ActionEvent event)
    {
      String command = event.getActionCommand();

      if (command.equals("OK"))
      {
        this.setVisible(false);
      }
    }
  }

}